#include <iostream>

using namespace std;

class Tier {
   protected:
    string name;

   public:
    Tier(string n) : name(n){};
    string get_name() { return name; }
    virtual void machLaut() = 0;
};

// Klasse Kuh muss Methode essen implementiert haben
class Cow : public Tier {
   public:
    Cow(string n) : Tier(n){};
    void machLaut() { cout << "Muuh" << endl; }
};

// Klasse Hund muss Methode essen implementiert haben
class Hund : public Tier {
   public:
    Hund(string n) : Tier(n){};
    void machLaut() { cout << "Wuff" << endl; }
};

int main() {
    Cow k("Betsy");
    Hund h("Bello");

    cout << k.get_name() << " macht ";
    k.machLaut();
    cout << h.get_name() << " macht ";
    h.machLaut();

    return 0;
}
