#include <iostream>

using namespace std;

class Polygon {
   protected:
    int laenge, breite;

   public:
    void set_values(int l, int w) {
        laenge = l;
        breite = w;
    }
    virtual int flaeche() { return 0; }

    // Rein virtuelle Methode:
    //
    // virtual int flaeche() = 0;
};

class Rechteck : public Polygon {
   public:
    int flaeche() { return laenge * breite; }
};

class Dreieck : public Polygon {
   public:
    int flaeche() { return (laenge * breite) / 2; }
};

int main() {
	Polygon poly;
	Rechteck rech;
	Dreieck drei;
	Polygon *poly1 = &poly;
	Polygon *poly2 = &rech;
	Polygon *poly3 = &drei;
	poly1->set_values(4,5);
	poly2->set_values(4,5);
	poly3->set_values(4,5);
	cout << poly1->flaeche() << endl;
	cout << poly2->flaeche() << endl;
	cout << poly3->flaeche() << endl;
	
	// Code für rein virtuelle Methode:
	//	Rechteck rech;
	//	Dreieck drei;
	//	Polygon *poly2 = &rech;
	//	Polygon *poly3 = &drei;
	//	poly2->set_values(4,5);
	//	poly3->set_values(4,5);
	//	cout << poly2->flaeche() << endl;
	//	cout << poly3->flaeche() << endl;

    return 0;
}
