#include <iostream>

using namespace std;

class Euro {
   private:
    int euro;
    int cent;

   public:
    Euro() : euro(0), cent(0) {}
    Euro(int e) : euro(e), cent(0) {}
    Euro(int e, int c) : euro(e), cent(c) {}
    void ausgabe() { cout << euro << "," << cent << endl; }
    friend Euro operator+(const Euro &a, const Euro &b);
    friend Euro operator-(const Euro &a, const Euro &b);
    Euro operator*(const double &z);
};

Euro operator+(const Euro &a, const Euro &b) {
    Euro erg;

    erg.euro = a.euro + b.euro;
    erg.cent = a.cent + b.cent;
    while (erg.cent >= 100) {
        erg.cent = erg.cent - 100;
        erg.euro++;
    }
    return erg;
}

Euro operator-(const Euro &a, const Euro &b) {
    Euro erg;

    erg.euro = a.euro - b.euro;
    erg.cent = a.cent - b.cent;
    while (erg.cent < 0) {
        erg.cent = 100 + erg.cent;
        erg.euro--;
    }
    return erg;
}

Euro Euro::operator*(const double &z) {
    cent = cent * z;
    euro = euro * z;

    if (z > 0) {
        while (cent >= 100) {
            cent = cent - 100;
            euro++;
        }
    } else if (z < 0) {
        while (cent <= -100) {
            cent = cent + 100;
            euro--;
        }
    }

    return *this;
}

int main() {
    Euro meinGeld(100, 80), deinGeld(45, 30), strafe(25, 80), unserGeld;
    double zinsen = 3.5;
    unserGeld = meinGeld + deinGeld;
    unserGeld.ausgabe();
    unserGeld = unserGeld - strafe;
    unserGeld.ausgabe();
    unserGeld = unserGeld.operator*(zinsen);
    unserGeld.ausgabe();

    return 0;
}
