#include <iostream>

using namespace std;

class Kunde {
   protected:
    float Zahlung;

   public:
    virtual void Zahlen(float Zahlung) {
        this->Zahlung=Zahlung;
        cout << "Kunde:" << this->Zahlung << endl;
    };
};

class Neukunde : public Kunde {
   public:
    void Zahlen(float Zahlung) {
        this->Zahlung = Zahlung * 0.9;
        cout << "Neukunde:" << this->Zahlung << endl;
    }
};

class Stammkunde : public Kunde {
   public:
    void Zahlen(float Zahlung) {
        this->Zahlung = Zahlung * 0.8;
        cout << "Stammkunde:" << this->Zahlung << endl;
    }
};

// this -> Nimmt die Eigenschaft von der eigenen/Basis-Klasse
// ohne this -> Nimmt die Übergabevariable

void Bezahlen(Kunde &Person, float Sum) { Person.Zahlen(Sum); }

int main() {
    Kunde Hansen, Meier;
    Neukunde Mueller;
    Stammkunde Gaston, Baumann;

    Bezahlen(Hansen, 50);
    Bezahlen(Meier, 70);

    Bezahlen(Mueller, 100);

    Bezahlen(Gaston, 200);
    Bezahlen(Baumann, 300);

    return 0;
}
