#include <iostream>

using namespace std;

class Datum {
   public:
    int tag, monat, jahr;

   public:
    friend istream &operator>>(istream &is, const Datum &dt);
    friend ostream &operator<<(ostream &os, const Datum &dt);
};

istream &operator>>(istream &is, Datum &dt) {
    cout << "Monat: ";
    do {
        is >> dt.monat;
    } while (dt.monat < 1 || dt.monat > 12);
    cout << "Tag: ";
    int tmp = 0;
    do {
        is >> dt.tag;
        if (dt.tag >= 1) {
            if (dt.monat == 1 || dt.monat == 3 || dt.monat == 5 || dt.monat == 7 || dt.monat == 8 || dt.monat == 10 || dt.monat == 12) {
                if (dt.tag <= 31) {
                    tmp = 1;
                }
            } else if (dt.monat == 2 && dt.tag <= 28) {
                tmp = 1;
            } else if (dt.monat != 2 && dt.tag <= 30) {
                tmp = 1;
            }
        }
    } while (tmp == 0);
    cout << "Jahr: ";
    do {
        is >> dt.jahr;
    } while (dt.jahr < 0);
    return is;
}

ostream &operator<<(ostream &os, const Datum &dt) {
    os << dt.tag << '.' << dt.monat << '.' << dt.jahr;
    return os;
}

int main() {
    Datum dt;
    cin >> dt;
    cout << dt;

    return 0;
}
